#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

#define F_CPU 16000000
#include "utils.h"
int nr_nota;
int durata;

// fur elise
void update_song()
{
    durata -= 25;
    if (durata < 25) {
        OCR1A = 15625 / melody[nr_nota];
        OCR1B = OCR1A/2;
        TCNT1 = 0;
        durata = tempo[nr_nota] * 1.5;
        nr_nota = (nr_nota+1)%64;
    }
}

// happy birthday
void update_song1()
{
    durata -= 25;
    if (durata < 25) {
        OCR1A = 15625 / notes_hb[nr_nota];
        OCR1B = OCR1A/2;
        TCNT1 = 0;
        durata = beats[nr_nota]*1.5;
        nr_nota = (nr_nota+1)%27;
    }
}

// harry potter
void update_song2()
{
    durata -= 25;
    if (durata < 25) {
        OCR1A = 15625 / melody_harry[nr_nota];
        OCR1B = OCR1A/2;
        TCNT1 = 0;
        durata = noteDurations_harry[nr_nota] * 1.5;
        nr_nota = (nr_nota+1)%64;
    }
}

// starwars
void update_song3()
{
    durata -= 25;
    if (durata < 25) {
        OCR1A = 15625 / surprise_notes[nr_nota];
        OCR1B = OCR1A/2;
        TCNT1 = 0;
        durata = durations_starwars[nr_nota]/2;
        nr_nota = (nr_nota+1)%64;
    }
}

/* aprind coloanele in spirala*/
void rotate(){
	PORTB |= (1<< PB0);
	PORTB |= (1<< PB1);
	PORTB |= (1<< PB2);
	PORTB |= (1<< PB3);
	
	PORTA |= (1 << PA7);
	update_song();
	_delay_ms(100);
	PORTA &= ~(1 << PA7);
	PORTA |= (1 << PA3);
	_delay_ms(100);
	PORTA &= ~(1 << PA3);
	PORTB |= (1 << PB4);
	_delay_ms(100);
	PORTB &= ~(1 << PB4);
	PORTC |= (1 << PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);
	PORTB |= (1 << PB6);
	update_song();
	_delay_ms(100);
	PORTB &= ~(1 << PB6);
	PORTC |= (1 << PC6);
	_delay_ms(100);
	PORTC &= ~(1 << PC6);
	PORTB |= (1 << PB7);
	_delay_ms(100);
	PORTB &= ~(1 << PB7);
	PORTB |= (1 << PB5);
	_delay_ms(100);
	PORTB &= ~(1 << PB5);
	PORTA |= (1 << PA0);
	update_song();
	_delay_ms(100);
	PORTA &= ~(1 << PA0);
	PORTA |= (1 << PA4);
	_delay_ms(100);
	PORTA &= ~(1 << PA4);
	PORTA |= (1 << PA5);
	_delay_ms(100);
	PORTA &= ~(1 << PA5);
	PORTA |= (1 << PA6);
	_delay_ms(100);
	PORTA &= ~(1 << PA6);
	PORTA |= (1 << PA2);
	update_song();
	_delay_ms(100);
	PORTA &= ~(1 << PA2);
	PORTC |= (1 << PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	PORTC |= (1 << PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	PORTA |= (1 << PA1);
	_delay_ms(100);
	update_song();
	PORTA &= ~(1 << PA1);
}
/* altfel de spirala */
void rotate2(){
	PORTB |= (1<< PB0);
	PORTB |= (1<< PB1);
	PORTB |= (1<< PB2);
	PORTB |= (1<< PB3);
	
	PORTA &= ~(1 << PA7);
	update_song2();
	_delay_ms(100);
	PORTA |= (1 << PA7);
	PORTA &= ~(1 << PA3);
	_delay_ms(100);
	PORTA |= (1 << PA3);
	PORTB &= ~(1 << PB4);
	_delay_ms(100);
	PORTB |= (1 << PB4);
	PORTC &= ~(1 << PC4);
	_delay_ms(100);
	PORTC |= (1 << PC4);
	PORTB &= ~(1 << PB6);
	update_song2();
	_delay_ms(100);
	PORTB |= (1 << PB6);
	PORTC &= ~(1 << PC6);
	_delay_ms(100);
	PORTC |= (1 << PC6);
	PORTB &= ~(1 << PB7);
	_delay_ms(100);
	PORTB |= (1 << PB7);
	PORTB &= ~(1 << PB5);
	_delay_ms(100);
	PORTB |= (1 << PB5);
	PORTA &= ~(1 << PA0);
	update_song2();
	_delay_ms(100);
	PORTA |= (1 << PA0);
	PORTA &= ~(1 << PA4);
	_delay_ms(100);
	PORTA |= (1 << PA4);
	PORTA &= ~(1 << PA5);
	_delay_ms(100);
	PORTA |= (1 << PA5);
	PORTA &= ~(1 << PA6);
	_delay_ms(100);
	PORTA |= (1 << PA6);
	PORTA &= ~(1 << PA2);
	update_song2();
	_delay_ms(100);
	PORTA |= (1 << PA2);
	PORTC &= ~(1 << PC1);
	_delay_ms(100);
	PORTC = (1 << PC1);
	PORTC &= ~(1 << PC2);
	_delay_ms(100);
	PORTC |=(1 << PC2);
	PORTA &= ~(1 << PA1);
	_delay_ms(100);
	PORTA |= (1 << PA1);
	update_song2();
}
/* layere aprinse pe verticala */
void walls(){
	PORTB |= (1<< PB0);
	PORTB |= (1<< PB1);
	PORTB |= (1<< PB2);
	PORTB |= (1<< PB3);
	
	PORTA |= (1 << PA7);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA4);
	update_song1();
	_delay_ms(200);
	PORTA &= ~(1 << PA7);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA4);
	_delay_ms(200);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA0);
	_delay_ms(200);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA0);
	update_song1();
	_delay_ms(200);
	PORTB |= (1 << PB4);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC2);
	PORTB |= (1 << PB5);
	_delay_ms(200);
	PORTB &= ~(1 << PB4);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTB &= ~(1 << PB5);
	_delay_ms(200);
	PORTC |= (1 << PC4);
	PORTB |= (1 << PB6);
	PORTC |= (1 << PC6);
	PORTB |= (1 << PB7);
	update_song1();
	_delay_ms(200);
	PORTC &= ~(1 << PC4);
	PORTB &= ~(1 << PB6);
	PORTC &= ~(1 << PC6);
	PORTB &= ~(1 << PB7);
}

/* stinge toate ledurile */
void clear_all(){
	PORTB &= ~(1<< PB0);
	PORTB &= ~(1<< PB1);
	PORTB &= ~(1<< PB2);
	PORTB &= ~(1<< PB3);
	PORTA = 0;
	PORTC = 0;
}

/* aprinde toate ledurile */
void set_all(void) {
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);

	_delay_ms(100);
}

/* labirint */
void snake(){
	PORTB |= (1<< PB0);
	PORTB |= (1<< PB1);
	PORTB |= (1<< PB2);
	PORTB |= (1<< PB3);
	update_song3();
	PORTA |= (1 << PA7);
	_delay_ms(100);
	PORTA &= ~(1 << PA7);
	PORTA |= (1 << PA6);
	_delay_ms(100);
	PORTA &= ~(1 << PA6);
	PORTA |= (1 << PA5);
	update_song3();
	_delay_ms(100);
	PORTA &= ~(1 << PA5);
	PORTA |= (1 << PA4);
	_delay_ms(100);
	PORTA &= ~(1 << PA4);
	PORTA |= (1 << PA0);
	update_song3();
	_delay_ms(100);
	PORTA &= ~(1 << PA0);
	PORTA |= (1 << PA1);
	_delay_ms(100);
	PORTA &= ~(1 << PA1);
	PORTA |= (1 << PA2);
	update_song3();
	_delay_ms(100);
	PORTA &= ~(1 << PA2);
	PORTA |= (1 << PA3);
	_delay_ms(100);
	PORTA &= ~(1 << PA3);
	PORTB |= (1 << PB4);
	update_song3();
	_delay_ms(100);
	PORTB &= ~(1 << PB4);
	PORTC |= (1 << PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	PORTC |= (1 << PC2);
	update_song3();
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	PORTB |= (1 << PB5);
	_delay_ms(100);
	PORTB &= ~(1 << PB5);
	PORTC |= (1 << PC7);
	update_song3();
	_delay_ms(100);
	PORTC &= ~(1 << PC7);
	PORTC |= (1 << PC6);
	_delay_ms(100);
	PORTC &= ~(1 << PC6);
	PORTB |= (1 << PB6);
	update_song3();
	_delay_ms(100);
	PORTB &= ~(1 << PB6);
	PORTC |= (1 << PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

}

/* leyere pe orizontala */
void lightonLayers(){
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA7);

	PORTB &= ~(1 << PB4);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTB &= ~(1 << PB5);
	PORTC &= ~(1 << PC4);
	PORTB &= ~(1 << PB6);
	PORTC &= ~(1 << PC6);
	PORTB &= ~(1 << PB7);
	
	_delay_ms(200);
	PORTB |= (1<< PB1);
	_delay_ms(200);
	PORTB &= ~(1 << PB1);
	PORTB |= (1<< PB0);
	_delay_ms(200);
	PORTB &= ~(1 << PB0);
	PORTB |= (1<< PB3);
	_delay_ms(200);
	PORTB &= ~(1 << PB3);
	PORTB |= (1<< PB2);
	_delay_ms(200);
	PORTB &= ~(1 << PB2);
	
}

void IO_init()
{
    /* speaker-ul ca iesire */
    DDRD |= (1 << PD4);
	DDRA = 0xFF;
	DDRB = 0xFF;
	DDRC = 0xFF;
}

void timer1_init()
{
#if 0
    /* timer1 este configurat cu modul Normal, top 0xFFFF si prescaler 256 */
    TCCR1B |= (1 << CS12);
#endif
    TCCR1B |= (1 << CS10);
#if 0
    TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1);
#endif
    TCCR1A |= (1 << COM1A1) | (1 << COM1A0);

#if 0
    TCCR1A |= (1 << WGM11);
    TCCR1B |= (1 << WGM12) | (1 << WGM13);
#endif

#if 0
    ICR1 = 62500;
#endif
    ICR1 = 0xFFFF;
    TCCR1A |= (1 << COM1B1) | (1 << WGM10) | (1 << WGM11);
    TCCR1B |= (1 << WGM12) | (1 << WGM13) | (1 << CS12);
#if 0
    /* duty cycle-ul este setat initial la 25% */
    OCR1A = 0xFFFF / 4;
    /* duty cycle-ul initial pentru speaker (OC1B) este 50% */
    OCR1B = 0xFFFF / 2;
#endif
    OCR1A = ICR1 / 4;
    OCR1B = ICR1 / 2;
}

int main(void)
{
    sei();
    IO_init();
    timer1_init();

    OCR0A = 0;
    OCR1A = 0xFFFF;
    OCR2A = 0xFF;
    while(1)
    {		
			for(int i = 0; i < 7; i++){
				rotate2();
				_delay_ms(400);

			}
			for(int i = 0; i < 7; i++){
				rotate();
				_delay_ms(400);
			}
            
			for(int i = 0; i < 7; i++){
				walls();
				_delay_ms(100);
			}
			for(int i = 0; i < 10; i++){
				snake();
				_delay_ms(25);
			}
			for(int i = 0; i < 7; i++){
				lightonLayers();
				_delay_ms(100);
			}
	}		
		

    return 0;
}



