/* definitii note (Hz) */
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978

#define c    261
#define d    294
#define e    329
#define f    349
#define g    391
#define gS   415
#define a    440
#define aS   455
#define b    466
#define cH   523
#define cSH  554
#define dH   587
#define dSH  622
#define eH   659
#define fH   698
#define fSH  740
#define gH   784
#define gSH  830
#define aH   880

// happy birthday
int notes_hb[] = {NOTE_C4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_F4, NOTE_E4,
               NOTE_C4, NOTE_C4, NOTE_D4, NOTE_C4, NOTE_G4, NOTE_F4,
               NOTE_C4, NOTE_C4, NOTE_C5, NOTE_A4, NOTE_F4, NOTE_F4, NOTE_E4, NOTE_D4,
               NOTE_AS4, NOTE_AS4, NOTE_A4, NOTE_F4, NOTE_G4, NOTE_F4};
int beats[] = {4, 4, 2, 2, 2, 1,
               4, 4, 2, 2, 2, 1,
               4, 4, 2, 2, 4, 4, 2, 1,
               4, 4, 2, 2, 2, 1}; 

//starwars
uint16_t surprise_notes[] = {a, a, a, f, cH, a, f, cH, a, eH, eH, eH, fH, cH, gS, f, cH, a, aH, a, a, aH, gSH, gH, fSH, fH, fSH, aS, dSH, dH, cSH, cH, b, cH, f, gS, f, a, cH, a, cH, eH, aH, a, a, aH, gSH, gH, fSH, fH, fSH, aS, dSH, dH, cSH, cH, b, cH, f, gS, f, cH, a, f, cH, a};
uint16_t durations_starwars[] = {500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 125, 500, 375, 125, 500, 375, 125, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 250, 500, 375, 125, 500, 375, 125, 650};
uint8_t num_notes = sizeof(durations_starwars) / sizeof(durations_starwars[0]);

//fur elise
int melody[] = {
  NOTE_E5, NOTE_DS5, NOTE_E5, NOTE_DS5,
  NOTE_E5, NOTE_B4, NOTE_D5, NOTE_C5,
  NOTE_A4, NOTE_C4, NOTE_E4, NOTE_A4,
  NOTE_B4, NOTE_E4, NOTE_GS4, NOTE_B4,
  
  NOTE_C5, NOTE_E4, NOTE_E5, NOTE_DS5,
  NOTE_E5, NOTE_DS5, NOTE_E5, NOTE_B4,
  NOTE_D5, NOTE_C5, NOTE_A4, NOTE_C4,
  NOTE_E4, NOTE_A4, NOTE_B4, NOTE_E4,
  
  NOTE_C5, NOTE_B4, NOTE_A4, NOTE_B4,
  NOTE_C5, NOTE_D5, NOTE_E5, NOTE_G4,
  NOTE_F5, NOTE_E5, NOTE_D5, NOTE_F4,
  NOTE_E5, NOTE_D5, NOTE_C5, NOTE_E4,
  
  NOTE_D5, NOTE_C5, NOTE_B4, NOTE_E4,
  NOTE_E5, NOTE_E4, NOTE_E5, NOTE_E4,
  NOTE_E5, NOTE_E4, NOTE_E5, NOTE_DS4,
  NOTE_E5, NOTE_D4, NOTE_E5, NOTE_DS4,
  
  NOTE_E5, NOTE_B4, NOTE_D5, NOTE_C5,
  NOTE_A4, NOTE_C4, NOTE_E4, NOTE_A4,
  NOTE_B4, NOTE_E4, NOTE_GS4, NOTE_B4,
  NOTE_C5, NOTE_E4, NOTE_E5, NOTE_DS5,

  NOTE_E5, NOTE_DS5, NOTE_E5, NOTE_B4,
  NOTE_D5, NOTE_C5, NOTE_A4, NOTE_C4,
  NOTE_E4, NOTE_A4, NOTE_B4, NOTE_E4,
  NOTE_C5, NOTE_B4, NOTE_A4, 0,
  
};

int tempo[] = {
  9, 9, 9, 9,
  9, 9, 9, 9,
  3, 9, 9, 9,
  3, 9, 9, 9,

  3, 9, 9, 9,
  9, 9, 9, 9,
  9, 9, 3, 9,
  9, 9, 3, 9,

  9, 9, 3, 9,
  9, 9, 3, 9,
  9, 9, 3, 9,
  9, 9, 3, 9,

  9, 9, 9, 9,
  9, 9, 9, 9,
  9, 9, 9, 9,
  9, 9, 9, 9,

  9, 9, 9, 9,
  3, 9, 9, 9,
  3, 9, 9, 9,
  3, 9, 9, 9,

  9, 9, 9, 9,
  9, 9, 3, 9,
  9, 9, 3, 8,
  8, 8, 1, 9,
};


//got
int notes_got[] = {NOTE_G4, NOTE_C4, NOTE_DS4,
NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_E4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_E4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_E4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_E4, NOTE_F4,
NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_F4, NOTE_AS3, NOTE_DS4, NOTE_D4, NOTE_F4, NOTE_AS3, NOTE_DS4, NOTE_D4, NOTE_C4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_F3,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_F3,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_F3,
NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4, NOTE_G4, NOTE_C4, NOTE_DS4, NOTE_F4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4,
NOTE_G3, NOTE_AS3, NOTE_C4, NOTE_D4};

int durations_got[] = {500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250,
500, 500, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 1000,
1000, 1000, 250, 250, 1000, 1000, 250, 250, 500,
250, 250, 500, 500,
250, 250, 500, 500,
250, 250, 500, 500,
1000, 1000, 250, 250, 1000, 1000, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 500,
500, 250, 250, 500};

// harry potter
int melody_harry[] =
{
NOTE_B5, NOTE_E5, NOTE_G5, NOTE_FS5, NOTE_E5, NOTE_B6, NOTE_A6, NOTE_FS5, NOTE_E5, NOTE_G5,
NOTE_FS5,  NOTE_DS5, NOTE_F5, NOTE_B4, NOTE_B4, NOTE_E5, NOTE_G5, NOTE_FS5, NOTE_E5, NOTE_B6,
NOTE_D6, NOTE_CS6, NOTE_C6, NOTE_GS6, NOTE_C6, NOTE_B6, NOTE_GS5, NOTE_GS4, NOTE_G5, NOTE_E5,
NOTE_G5, NOTE_B6, NOTE_G5, NOTE_B6, NOTE_G5, NOTE_C6, NOTE_B5, NOTE_AS5, NOTE_FS5, NOTE_G5, 
NOTE_B5, NOTE_AS5, NOTE_AS4, NOTE_B4, NOTE_B5

};

int noteDurations_harry[] =
{
8, 6, 16, 8, 4, 8, 3, 3, 6, 16, 
8, 5, 4, 4, 8, 6, 16, 8, 4, 8,
4, 8, 4, 8, 6, 16, 8, 4, 8, 3, 
8, 4, 8, 4, 8, 4, 8, 4, 8, 6, 
16, 8, 4, 8, 3
};